<?php
/**
 * @file
 * C-Tools integration for Open AdStream.
 */

/**
 * Implementation of hook_ctools_content_types().
 */
function openadstream_ads_ctools_content_types() {
  return array(
    'title' => t('Open AdStream Ads'),
  );
}

/**
 * Return all content types available.
 */
function openadstream_ads_content_type_content_types($plugin) {
  $types = array();

  $ads = openadstream_all_positions();

  foreach($ads as $ad) {
    $types[$ad['name']] = openadstream_ads_content_type_content_type($ad);
  }

  return $types;
}

function openadstream_ads_content_type_content_type($ad, $plugin = '') {
  return array(
    'title' => $ad['name'],
    'description' => $ad['description'],
    'category' => 'Open AdStream Ads',    
  );
}

/**
 * Implementation of hook_ctools_content_type_render().
 */
function openadstream_ads_content_type_render($subtype, $conf, $panel_args, $contexts) {
  // See if this ad should be displayed.
  if (openadstream_check_position()) {
    return;
  }

  // Build a block-like option to display this pane.
  $block = new StdClass;
  $block->content = openadstream_output_ad($subtype);
  $block->title = '';
  $block->delta = $subtype;
  $block->css_class = 'oas-ad oas-' . strtolower($subtype);
  return $block;
}

/**
 * Implementation of hook_ctools_content_type_admin_title().
 */
function openadstream_ads_content_type_admin_title($subtype, $conf, $contexts) {
  return 'Open AdStream Ads: ' . $subtype;
}

/**
 * Implementation of hook_ctools_content_type_admin_info().
 */
function openadstream_ads_content_type_admin_info($subtype, $conf, $contexts) {
  $block = new StdClass;
  $block->title = $subtype;
  $block->content = l('Settings may be modified', 'admin/settings/openadstream') . ', if needed';
  return $block;
}
